VMSTAT(8)

NAME
vmstat - report virtual memory statistics

SYNOPSIS
vmstat [-afHhimPsz] [-c count] [-M core [-N system]] [-w wait] [-n devs] [ -p type,if,pass] [disks]

DESCRIPTION
The vmstat utility reports certain kernel statistics kept about process, virtual memory, disk, trap and cpu activity.

If the -M option is not specified, information is obtained from the currently running kernel via the sysctl(3) interface. Otherwise, information is read from the specified core file, using the name list from the specified kernel image (or from the default image).

The options are as follows:

-a  When used with -i, include statistics about interrupts that have never been generated.

-c  Repeat the display count times. The first display is for the time since a reboot and each subsequent report is for the time period since the last display. If no repeat count is specified, and -w is specified, the default is infinity, otherwise the default is one.

-f  Report on the number fork(2), vfork(2) and rfork(2) system calls since system startup, and the number of pages of virtual memory involved in each.

-h  Changes memory columns into more easily human readable form. Default if standard output is a terminal device.

-H  Changes memory columns into straight numbers. Default if standard output is not a terminal device (such as a script).

-i  Report on the number of interrupts taken by each device since system startup.

-M  Extract values associated with the name list from the specified core.

-N  If -M is also specified, extract the name list from the specified system instead of the default, which is the kernel image the system has booted from.

-m  Report on the usage of kernel dynamic memory allocated using malloc(9) by type.

-n  Change the maximum number of disks to display from the default of 2.

-P  Report per-cpu system/user/idle cpu statistics.

-p  Specify which types of devices to display. There are three different categories of devices:

    device type:
        da  Direct Access devices
        sa  Sequential Access devices
        printer
            Printers
        proc
            Processor devices
        worm
            Write Once Read Multiple devices
        cd  CD devices
        scanner
            Scanner devices
        optical
            Optical Memory devices
        changer
            Medium Changer devices
        comm
            Communication devices
        array
            Storage Array devices
        enclosure
            Enclosure Services devices
        floppy
            Floppy devices

    interface:
        IDE Integrated Drive Electronics devices
        SCSI
            Small Computer System Interface devices
        other
            Any other device interface

    passthrough:
        pass
            Passthrough devices

    The user must specify at least one device type, and may specify at most one device type from each category. Multiple device types in a single device type statement must be separated by commas.

    Any number of -p arguments may be specified on the command line. All -p arguments are ORed together to form a matching expression against which all devices in the system are compared. Any device that fully matches any -p argument will be included in the vmstat output, up to two devices, or the maximum number of devices specified by the user.

-s  Display the contents of the sum structure, giving the total number of several kinds of paging related events which have occurred since system startup.

-w  Pause wait seconds between each display. If no repeat wait interval is specified, the default is 1 second. The vmstat command will accept and honor a non-integer number of seconds.

-z  Report on memory used by the kernel zone allocator, uma(9), by zone.

By default, vmstat displays the following information:

procs
    Information about the numbers of processes in various states.

    r   in run queue
    b   blocked for resources (i/o, paging, etc.)
    w   runnable or short sleeper (< 20 secs) but swapped

memory
    Information about the usage of virtual and real memory. Virtual pages (reported in units of 1024 bytes) are considered active if they belong to processes which are running or have run in the last 20 seconds.

    avm active virtual pages
    fre size of the free list

page
    Information about page faults and paging activity. These are averaged each five seconds, and given in units per second.

    flt total number of page faults
    re  page reclaims (simulating reference bits)
    pi  pages paged in
    po  pages paged out
    fr  pages freed per second
    sr  pages scanned by clock algorithm, per-second

disks
    Disk operations per second (this field is system dependent). Typically paging will be split across the available drives. The header of the field is the first two characters of the disk name and the unit number. If more than two disk drives are configured in the system, vmstat displays only the first two drives, unless the user specifies the -n argument to increase the number of drives displayed. This will probably cause the display to exceed 80 columns, however. To force vmstat to display specific drives, their names may be supplied on the command line. The vmstat utility defaults to show disks first, and then various other random devices in the system to add up to two devices, if there are that many devices in the system. If devices are specified on the command line, or if a device type matching pattern is specified (see above), vmstat will only display the given devices or the devices matching the pattern, and will not randomly select other devices in the system.

faults
    Trap/interrupt rate averages per second over last 5 seconds.

    in  device interrupts per interval (including clock interrupts)
    sy  system calls per interval
    cs  cpu context switch rate (switches/interval)

cpu Breakdown of percentage usage of CPU time.

    us  user time for normal and low priority processes
    sy  system time
    id  cpu idle

FILES
/boot/kernel/kernel
    default kernel namelist
/dev/kmem
    default memory file

EXAMPLES
The command:
    vmstat -w 5
will print what the system is doing every five seconds; this is a good choice of printing interval since this is how often some of the statistics are sampled in the system. Others vary every second and running the output for a while will make it apparent which are recomputed every second.

The command:
    vmstat -p da -p cd -w 1
will tell vmstat to select the first two direct access or CDROM devices and display statistics on those devices, as well as other systems statistics every second.

SEE ALSO
fstat(1), netstat(1), nfsstat(1), ps(1), systat(1), libmemstat(3), gstat(8), iostat(8), pstat(8), sysctl(8), malloc(9), uma(9)

The sections starting with ``Interpreting system activity'' in

BUGS
The -c and -w options are only available with the default output.